package com.sf.web.dms.faultlist.service.impl;

package ..deTemp.1731586859043;

import com.sf.web.dms.abnormal.bean.RiskQueryParaVO;
import com.sf.web.dms.faultlist.dao.DaFaultOpenOrmDao;
import com.sf.web.dms.faultlist.entity.DaFaultOpen;
import com.sf.web.dms.faultlist.entity.DaFaultOpenPK;
import com.sf.web.dms.faultlist.service.MyDaFaultGroundFeederService;
import com.sf.web.dms.util.SysCommUtil;
import com.smartframework.core.dao.JdbcDao;
import com.smartframework.core.dao.page.PagingBean;
import com.smartframework.core.i18n.I18n;
import com.smartframework.web.core.Constants;
import com.smartframework.web.core.queryfilter.QueryFilter;
import com.smartframework.web.core.util.AnnotationAccessUtil;
import com.smartframework.web.core.util.ParameterUtils;
import java.io.Serializable;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import org.apache.log4j.Logger;

public class MyDaFaultGroundFeederServiceImpl implements MyDaFaultGroundFeederService {
  private Logger logger = Logger.getLogger(com.sf.web.dms.faultlist.service.impl.MyDaFaultGroundFeederServiceImpl.class);
  
  private JdbcDao jdbcDao;
  
  private DaFaultOpenOrmDao daFaultOpenOrmDao;
  
  public JdbcDao getJdbcDao() {
    return this.jdbcDao;
  }
  
  public void setJdbcDao(JdbcDao jdbcDao) {
    this.jdbcDao = jdbcDao;
  }
  
  public DaFaultOpenOrmDao getDaFaultOpenOrmDao() {
    return this.daFaultOpenOrmDao;
  }
  
  public void setDaFaultOpenOrmDao(DaFaultOpenOrmDao daFaultOpenOrmDao) {
    this.daFaultOpenOrmDao = daFaultOpenOrmDao;
  }
  
  public String save(DaFaultOpen daFaultOpen) {
    try {
      if (!ParameterUtils.isNotValidateId(daFaultOpen.getId())) {
        DaFaultOpen oldEntity = (DaFaultOpen)this.daFaultOpenOrmDao.findOne((Serializable)daFaultOpen.getId());
        AnnotationAccessUtil.mergeEntity(oldEntity, daFaultOpen);
      } 
      AnnotationAccessUtil.validateEntityBean(daFaultOpen);
      this.daFaultOpenOrmDao.save(daFaultOpen);
    } catch (Exception e) {
      this.logger.warn("Save daFaultOpen Error", e);
      return I18n.message("error.save.validate", "对象保存时失败{0}", new Object[] { e.getMessage() });
    } 
    return Constants.SUCCESS;
  }
  
  public String saveList(List<DaFaultOpen> daFaultOpenList) {
    try {
      this.daFaultOpenOrmDao.save(daFaultOpenList);
    } catch (Exception e) {
      this.logger.warn("Bacth Save daFaultOpen Error", e);
      return I18n.message("error.save.validate", "对象批量保存时失败{0}", new Object[] { e.getMessage() });
    } 
    return Constants.SUCCESS;
  }
  
  public List<DaFaultOpen> loadRecords(List<DaFaultOpenPK> idList) {
    return this.daFaultOpenOrmDao.findAll(idList);
  }
  
  public String delete(List<DaFaultOpenPK> idList, boolean permanently) {
    try {
      List<DaFaultOpen> list = this.daFaultOpenOrmDao.findAll(idList);
      if (permanently) {
        this.daFaultOpenOrmDao.delete(list);
      } else {
        for (DaFaultOpen daFaultOpen : list);
        this.daFaultOpenOrmDao.save(list);
      } 
    } catch (Exception e) {
      return e.getMessage();
    } 
    return Constants.SUCCESS;
  }
  
  public DaFaultOpen get(DaFaultOpenPK id) {
    if (ParameterUtils.isNotValidateId(id))
      return null; 
    return (DaFaultOpen)this.daFaultOpenOrmDao.findOne((Serializable)id);
  }
  
  public PagingBean queryRecords(QueryFilter queryFilter) {
    String sql = "select e.* from da_fault_open e";
    return this.jdbcDao.queryForPaging(sql + queryFilter.getWhereSql(), queryFilter.getConditionValues(), queryFilter.getPageSize().intValue(), queryFilter.getPageIndex().intValue());
  }
  
  public Map<Long, String> queryFeederRecords(RiskQueryParaVO paraVO) {
    Integer level = paraVO.getLevel();
    Integer orgId = paraVO.getOrgId();
    String userAuthOrgLinkSQL = SysCommUtil.userAuthOrgLinkSQL(level, orgId);
    StringBuilder sql = new StringBuilder("select e.id, e.description from con_feeder e ");
    QueryFilter filter = new QueryFilter();
    if (paraVO.getContainerId() != null && paraVO.getContainerName() != null) {
      Long containerId = paraVO.getContainerId();
      String containerName = paraVO.getContainerName();
      filter.addNumberFieldEqualCondition("e." + containerName + "_id", containerId);
    } else {
      sql.append("inner join (");
      sql.append("select distinct ort.container_id from auth_orgrtu ort inner join (").append(userAuthOrgLinkSQL).append(") org on ort.org_id=org.user_auth_org_id");
      sql.append(") org_feeder on org_feeder.container_id=e.id ");
    } 
    List<Map<String, Object>> ret = this.jdbcDao.queryForList(sql + filter.getWhereSql(), filter.getConditionValues());
    Map<Long, String> feederIdNameMap = new HashMap<>();
    for (Map<String, Object> item : ret)
      feederIdNameMap.put((Long)item.get("id"), item.get("description").toString()); 
    return feederIdNameMap;
  }
  
  public PagingBean queryDaFaultRecords(QueryFilter queryFilter) {
    String sql = "select e.id as id,e.fault_time as fault_time,e.start_cond as start_cond,e.da_exec_result as da_exec_result,e.description as description,e.update_time as update_time,e.breaker_id as breaker_id,d1.description as breaker_description,e.feeder_id as feeder_id,con_feeder.description as feeder_name,e.station_id as station_id,con_station.description as station_name,e.da_status as da_status,e.fault_mode as fault_mode,da_fault_area.fault_type as fault_type,da_fault_area.boarddev_id as boarddev_id,da_fault_area.id as fault_area_id,da_fault_area.description as fault_area_description,da_fault_area.breaker_id as fault_area_breaker_id from da_fault_info e LEFT JOIN con_feeder ON e.feeder_id=con_feeder.id LEFT JOIN con_station ON e.station_id=con_station.id LEFT JOIN obj_dev as d1 ON d1.id=e.breaker_id LEFT JOIN da_fault_area ON da_fault_area.fault_id=e.id";
    return this.jdbcDao.queryForPaging(sql + queryFilter.getWhereSql(), queryFilter.getConditionValues(), queryFilter.getPageSize().intValue(), queryFilter.getPageIndex().intValue());
  }
}
